'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _foldToObject(memo, _ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      k = _ref2[0],
      v = _ref2[1];

  memo[k] = v;
  return memo;
}

function _objectMap(obj, fn) {
  return _entries(obj).map(fn).reduce(_foldToObject, {});
}

function _entries(obj) {
  var stringKeys = Object.getOwnPropertyNames(obj);
  var symKeys = Object.getOwnPropertySymbols(obj);
  return [].concat(_toConsumableArray(stringKeys), _toConsumableArray(symKeys)).map(function (p) {
    return [p, obj[p]];
  });
}

if (typeof Protocol === 'undefined') {
  var global = Function('return this')();
  global.Protocol = function (_ref3) {
    _inherits(Protocol, _ref3);

    function Protocol() {
      var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          protocolName = _ref4.name,
          _ref4$extends = _ref4.extends,
          _extends = _ref4$extends === undefined ? [] : _ref4$extends,
          _ref4$symbols = _ref4.symbols,
          symbols = _ref4$symbols === undefined ? {} : _ref4$symbols,
          _ref4$staticSymbols = _ref4.staticSymbols,
          staticSymbols = _ref4$staticSymbols === undefined ? {} : _ref4$staticSymbols,
          _ref4$protoProperties = _ref4.protoProperties,
          protoProperties = _ref4$protoProperties === undefined ? {} : _ref4$protoProperties,
          _ref4$staticPropertie = _ref4.staticProperties,
          staticProperties = _ref4$staticPropertie === undefined ? {} : _ref4$staticPropertie;

      _classCallCheck(this, Protocol);

      var _this = _possibleConstructorReturn(this, (Protocol.__proto__ || Object.getPrototypeOf(Protocol)).call(this));

      _this._name = protocolName;
      _this._extends = _extends;
      _this._symbols = _objectMap(symbols, function (_ref5) {
        var _ref6 = _slicedToArray(_ref5, 2),
            name = _ref6[0],
            sym = _ref6[1];

        return [name, sym == null ? _this._createSymbol(name, { value: sym }) : sym];
      });
      _this._staticSymbols = _objectMap(staticSymbols, function (_ref7) {
        var _ref8 = _slicedToArray(_ref7, 2),
            name = _ref8[0],
            sym = _ref8[1];

        return [name, sym == null ? _this._createSymbol(name, { value: sym }) : sym];
      });
      _this._protoProperties = protoProperties;
      _this._staticProperties = staticProperties;
      // TODO: check that there's no conflicts between symbols/staticSymbols/protoProperties/staticProperties
      Object.assign(_this, _this._symbols, _this._staticSymbols, _objectMap(protoProperties, function (_ref9) {
        var _ref10 = _slicedToArray(_ref9, 2),
            name = _ref10[0],
            desc = _ref10[1];

        return [name, _this._createSymbol(name, desc)];
      }), _objectMap(staticProperties, function (_ref11) {
        var _ref12 = _slicedToArray(_ref11, 2),
            name = _ref12[0],
            desc = _ref12[1];

        return [name, _this._createSymbol(name, desc)];
      }));
      return _this;
    }

    _createClass(Protocol, [{
      key: '_createSymbol',
      value: function _createSymbol(propName, propDescriptor) {
        if ((typeof propName === 'undefined' ? 'undefined' : _typeof(propName)) === 'symbol') return propName;
        var interfaceName = this._name == null ? '' : this._name + '.';
        var description = '' + interfaceName + propName;
        if (propDescriptor.get != null && propDescriptor.set == null) {
          description = 'get ' + description;
        } else if (propDescriptor.get == null && propDescriptor.set != null) {
          description = 'set ' + description;
        }
        return Symbol(description);
      }
    }, {
      key: '_isImplementedBy',
      value: function _isImplementedBy(klass) {
        var _this2 = this;

        return [].concat(_toConsumableArray(Object.values(this._symbols)), _toConsumableArray(Object.keys(this._protoProperties).map(function (name) {
          return _this2[name];
        }))).every(function (sym) {
          return sym in klass.prototype;
        }) && [].concat(_toConsumableArray(Object.values(this._staticSymbols)), _toConsumableArray(Object.keys(this._staticProperties).map(function (name) {
          return _this2[name];
        }))).every(function (sym) {
          return sym in klass;
        });
      }
    }, {
      key: '_unimplemented',
      value: function _unimplemented(klass) {
        var protoSymbolsWhichWillBeInherited = this._collect(function (i) {
          return Object.getOwnPropertySymbols(i._protoProperties);
        });
        var staticSymbolsWhichWillBeInherited = this._collect(function (i) {
          return Object.getOwnPropertySymbols(i._staticProperties);
        });
        return this._collect(function (i) {
          return i._unimplementedHelper(klass, protoSymbolsWhichWillBeInherited, staticSymbolsWhichWillBeInherited);
        });
      }
    }, {
      key: '_unimplementedHelper',
      value: function _unimplementedHelper(klass, protoSymbolsWhichWillBeInherited, staticSymbolsWhichWillBeInherited) {
        var protoSymbolsWhichMustBeImplemented = Object.values(this._symbols);
        var staticSymbolsWhichMustBeImplemented = Object.values(this._staticSymbols);
        var unimplemented = [];
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = protoSymbolsWhichMustBeImplemented[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var symbol = _step.value;

            if (!(symbol in klass.prototype) && !protoSymbolsWhichWillBeInherited.includes(symbol)) {
              unimplemented.push(symbol);
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        var _iteratorNormalCompletion2 = true;
        var _didIteratorError2 = false;
        var _iteratorError2 = undefined;

        try {
          for (var _iterator2 = staticSymbolsWhichMustBeImplemented[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var _symbol = _step2.value;

            if (!(_symbol in klass) && !staticSymbolsWhichWillBeInherited.includes(_symbol)) {
              unimplemented.push(_symbol);
            }
          }
        } catch (err) {
          _didIteratorError2 = true;
          _iteratorError2 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion2 && _iterator2.return) {
              _iterator2.return();
            }
          } finally {
            if (_didIteratorError2) {
              throw _iteratorError2;
            }
          }
        }

        return unimplemented;
      }
    }, {
      key: '_collect',
      value: function _collect(fn) {
        return [].concat(_toConsumableArray(fn(this)), _toConsumableArray([].concat.apply([], this._extends.map(function (i) {
          return i._collect(fn);
        }))));
      }
    }, {
      key: '_mixin',
      value: function _mixin(klass) {
        var unimplementedSymbols = this._unimplemented(klass);
        if (unimplementedSymbols.length > 0) {
          throw new Error(unimplementedSymbols.map(function (s) {
            return s.toString();
          }).join(', ') + ' not implemented by ' + klass);
        }

        Object.defineProperties(klass.prototype, this._collect(function (i) {
          return _entries(i._protoProperties).filter(function (_ref13) {
            var _ref14 = _slicedToArray(_ref13, 1),
                name = _ref14[0];

            return !(name in klass.prototype);
          }).map(function (_ref15) {
            var _ref16 = _slicedToArray(_ref15, 2),
                name = _ref16[0],
                desc = _ref16[1];

            return [i[name], desc];
          });
        }).reduceRight(_foldToObject, {}));

        Object.defineProperties(klass, this._collect(function (i) {
          return _entries(i._staticProperties).filter(function (_ref17) {
            var _ref18 = _slicedToArray(_ref17, 1),
                name = _ref18[0];

            return !(name in klass);
          }).map(function (_ref19) {
            var _ref20 = _slicedToArray(_ref19, 2),
                name = _ref20[0],
                desc = _ref20[1];

            return [i[name], desc];
          });
        }).reduceRight(_foldToObject, {}));

        return klass;
      }
    }], [{
      key: 'implement',
      value: function implement(C) {
        if (typeof C !== 'function' || !C.prototype) {
          throw new TypeError('first parameter must have a [[Construct]] internal slot');
        }

        for (var _len = arguments.length, is = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          is[_key - 1] = arguments[_key];
        }

        is.forEach(function (i) {
          return i._mixin(C);
        });
        return C;
      }
    }]);

    return Protocol;
  }(null);
}